jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
--trackWidth = fif(jumping, 11.5, 7)
ispuzzle = skinvars.colorcount>1
fullsteep = jumping or skinvars.prefersteep or (not ispuzzle)

SetScene{
	glowpasses = ifhifi(4,0),
	glowspread = ifhifi(0.5,0),
	radialblur_strength = .5,
--	radialblur_strength = fif(jumping,2,0),
	--environment = "city",
	watertype = 2,
	water = jumping, --only use the water cubes in wakeboard mode
	watertint = {r=255,g=255,b=255,a=234},
	watertexture = "block2.png",--texture used to color the dynamic "digital water" surface
	towropes = jumping,--use the tow ropes if jumping
	airdebris_count = 0,
	airdebris_density = 0,
	useblackgrid=false,
	twistmode={curvescaler=1, steepscaler=0.75} -- note: "cork" is the same as {curvescaler=1, steepscaler=1} and "cork_flatish" is the same as {curvescaler=1, steepscaler=.4}
}

SetPuzzleGraphics{
	usesublayerclone = false,
	puzzlematerial={
		texture = "tiles_coin.png",
		shader = "Unlit/Transparent"
		},
	puzzlematchmaterial={
		texture = "tilematch_sq.png",
		shader = "Particles/Additive"
	},
	puzzleflyupmaterial={
		texture = "tilefly_sq.png",
		shader = "Particles/Additive"
	}
}

if not jumping then
	SetBlocks{
		colorblocks={
			mesh = "shroom.obj",
			--meshmorph = "shroom.obj",
			--meshmorphtype = "intensity",
			--meshmorphsmoothspeed = 4,
			shader = "VertexColorUnlitTinted",
			texture = "shroom.png",
		    height = 0,
		    float_on_water = false,
		    scale = {1,1,.75}
		},
		greyblocks={
			mesh = "banan.obj",
			meshmorph = "banan.obj",
			meshmorphtype = "intensity",
			meshmorphsmoothspeed = 0,
			shader = "VertexColorUnlitTinted",
			texture = "banantext.png"
		},
		powerups={
			ghost={mesh = "golden.obj",
			shader = "VertexColorUnlitTinted",
			texture = "shroom2.png"},

			powerpellet={mesh = "golden.obj",
			shader = "VertexColorUnlitTinted",
			texture = "golden.png"}
		}
		}
end

SetPlayer{
	--showsurfer = false,
	--showboard = false,
	cameramode = "third",
--	cameramode_air = "first",--"first_jumptrickthird", --start in first, go to third for jumps and tricks

	camfirst={
		pos={0,1.84,-0.8},
		rot={20,0,0}},
	camthird={
		pos={0,2,-0.5},
		rot={30,0,0},
		strafefactorFar = .75,
		pos2={0,5,-4},
		rot2={30,0,0},
		strafefactorFar = 1,
		transitionspeed = 1,
		puzzleoffset=-0.65,
		puzzleoffset2=-1.5},
	vehicle={ --livecoding not supported here
		min_hover_height= 0.23,
		max_hover_height = 0.8,
		use_water_rooster = false,
		smooth_tilting = true,
		smooth_tilting_speed = 10,
		smooth_tilting_max_offset = -20,
		pos={x=0,y=0,z=0},
		mesh="kart.obj",
		shader="VertexColorUnlitTinted",
		layer = 14,
		renderqueue = 1000,
		shadercolors={
			_Color={255,255,255}},
		texture="kart.png",
		scale = {x=1,y=1,z=1},
	}
}

SetSkybox{
	skysphere="n64.png",
	color={r=255,g=255,b=255,a=0}
}

SetTrackColors{ --enter any number of colors here. The track will use the first ones on less intense sections and interpolate all the way to the last one on the most intense sections of the track
    {r=220, g=255, b=255},--grey
    {r=255, g=220, b=220}--white
}

if skinvars.colorcount < 5 then
	SetBlockColors{
	    {r=0, g=176, b=255},
	    {r=0, g=184, b=0},
	    {r=255, g=255, b=0},
		{r=255, g=0, b=0}
	}
else
	SetBlockColors{
	    {r=214, g=0, b=254},
	    {r=0, g=176, b=255},
	    {r=0, g=184, b=0},
	    {r=255, g=255, b=0},
		{r=255, g=0, b=0}
	}
end

if not jumping then
	CreateLight{
		type= "directional",
		railoffset = 0,
		intensity = .9,
		shadows={type="soft",strength=.58},
		transform = {
			position={0,2,0}, rotation={30,180,180}
		},
		color={255,127,0}
	}
end

SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture="Classic_OnBlack.png",
	--texture="Classic_OnBlack",
	shader="VertexColorUnlitTintedAddSmooth",
	layer = 13, -- on layer13, these objects won't be part of the glow effect
	size=0, --22
	percentringed=.1,--ifhifi(2,.01),-- .2,
	airtexture="Bits.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=16
}

wakeHeight = 2
if jumping then wakeHeight=2 else wakeHeight = 0 end
SetWake{ --setup the spray coming from the two pulling "boats"
	height = wakeHeight,
	fallrate = 0.95,
	shader = "VertexColorUnlitTinted",
	layer = 13, -- looks better not rendered in background when water surface is not type 2
	bottomcolor = {r=0,g=0,b=100},
	topcolor = "highway"
}

CreateObject{
	name="ring",
	tracknode="end",
	gameobject={
		transform={pos={0,0,22},scale={scaletype="intensity",min={1,1,1},max={1,2,1}}},
		mesh="endring.obj",
		shader="VertexColorUnlitTinted",
		shadercolors={
			_Color={255,255,255}
		},
		texture="ring.png"
	}
}



track = GetTrack()--get the track data from the game engine

if buildingNodes == nil then
	buildingNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	offsets = {}
	buildingNodesToo = {}
	offsetsToo = {}
	for i=1,#track do
		if i%80==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,-100,0}
		end

--		if (i+40)%120==0 then
--			buildingNodesToo[#buildingNodesToo+1] = i
--			local xOffset = 150 + 1650*math.random()
--			if math.random() > 0.5 then xOffset = xOffset * -1 end
--			offsetsToo[#offsetsToo+1] = {xOffset,-100,0}
--		end
	end

	if jumping then
		BatchRenderEveryFrame{prefabName="BuildingCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
								locations=buildingNodes,
	                    		rotateWithTrack=false,
	                    		maxShown=50,
	                    		maxDistanceShown=2000,
								offsets=offsets,
								collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
								testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
							}
	end
end


--RAILS. rails are the bulk of the graphics in audiosurf. Each one is a 2D shape extruded down the length of the track.


CreateRepeatedMeshRail{
    ahead_renderdist = 1500,
    behind_renderdist = 200,
    spacing = 85, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highway" --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = false, --set true if using lighting
    
	gameobject={
		name="meshrailproto1",
		shadowcaster = false,
		shadowreceiver = true,
		--mesh="pingpong.obj",
		mesh="star.obj",
		layer=13,
		shader="VertexColorUnlitTinted",
		shadercolors={
			_Color={r=255,g=255,b=255}
		},
		texture="star.png"
	}
}
CreateRepeatedMeshRail{
    ahead_renderdist = 1500,
    behind_renderdist = 200,
    spacing = 110, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highway" --"highwayinverted"

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = false, --set true if using lighting
    
	gameobject={
		name="meshrailproto1",
		shadowcaster = false,
		shadowreceiver = true,
		--mesh="pingpong.obj",
		mesh="star2.obj",
		layer=13,
		shader="VertexColorUnlitTinted",
		shadercolors={
			_Color={r=255,g=255,b=255}
		},
		texture="star.png"
	}
}
if not jumping then
	CreateRail{--road surface
	positionOffset={
		x=0,
		y=0},
	crossSectionShape={
		{x=-trackWidth-.5,y=-trackWidth/3},
		{x=-trackWidth,y=0},
		{x=trackWidth,y=0},
		{x=trackWidth+.5,y=-trackWidth/3}},
	perShapeNodeColorScalers={
		1,
		--1,
		2,
		2,
		--1,
		1
		},
	color = {r=255,g=255,b=255},
	flatten=false,
	fullfuture = true,--ifhifi(true,false),
	stretch = 1,
	texture= "road.png",
	shader = "VertexColorUnlitTinted",
	}
end








